

#import psyco
import pydfb as pygame
#import pygame
import time

COLOR= ( 0, 159, 222 )
CYCLES= 1000

def blit( screen, image, pos, rect= None ):
  if rect:
    screen.blit( image, pos, rect )
  else:
    screen.blit( image, pos )
  
  return image.get_width()* image.get_height()

def printText( screen, text, f, x ):
  s= f.render( text, 1, (157, 36, 128, x+150) )
  screen.blit( s, ( 0+x, 0+x ) )
  return s.get_width()* s.get_height()

def aaFontTest( screen ):
  # test font loading and rendering
  bg= pygame.image.load( 'data/bg.jpg' )
  f= pygame.font.Font( 'data/arialn.ttf', 80 )
  start= time.time()
  pix= 0
  for x in xrange( 0, CYCLES ):
    pix+= blit( screen, bg, (0,0) )
    t= 'This is a test'
    pix+= printText( screen, t, f, ( x % 100 ) )
    pygame.display.update()
  
  delta= time.time()- start
  print 'Text rendering: %.2f Mpix/sec' % ( pix / float( delta* 1000000 ) )

def aaFontAlpha( screen ):
  # test font loading and rendering
  bg= pygame.image.load( 'data/bg.jpg' )
  f= pygame.font.Font( 'data/arialn.ttf', 50 )
  start= time.time()
  pix= 0
  pix+= blit( screen, bg, (0,0) )
  a= 255
  for x in xrange( 0, 3 ):
    for y in xrange( 0, 10 ):
      t= 'Alpha'
      s= f.render( t, 1, (255, 255, 255, a) )
      screen.blit( s, ( x* 260+ 1, y*50+ 1 ) )
      a-= 8

  pygame.display.update()

#psyco.full()
pygame.init()

screen= pygame.display.set_mode( (800,600), 0, 32 )

aaFontTest( screen )
aaFontAlpha( screen )

pygame.event.wait()
pygame.quit()


"""
"""
