import pydfb as pygame
import time, pickle
SR=(800,600)

def getOverlay( overlay, f, t, a ):
  # Try to clip text such a way is that it will almost fit the screen
  t1= t
  while len( t )> 0 and f.size(t)[ 0 ]> screen.get_width():
    t1= t
    t= t[ 1: len( t )-1 ]
  
  s= f.render( t1, 1, (255,255,255) )
  # Create appropriate overlay
  w= min( screen.get_width(), s.get_width() )
  h= min( screen.get_height(), s.get_height() )
  x= ( screen.get_width()- w )/2
  y= ( screen.get_height()- h )/2
  print t1, x,y,w,h
  overlay.set_alpha( a )
  # Place text onto the overlay( with clipping if needed )
  cx= 0
  if w< s.get_width():
    cx= ( s.get_width()- w )/2
  cy= 0
  if h< s.get_height():
    cy= ( s.get_height()- h )/2
  os= overlay.surface()
  dx= (SR[0]-w)/2
  dy= (SR[1]-h)/2
  os.fill( (0,0,0), (dx,dy,w,h) )
  os.blit( s.subsurface( (cx, cy, w, h) ), (dx,dy))

pygame.init()
screen= pygame.display.set_mode( SR, 32 )
exit= 0
x= 2
txt= 'Your way to multimedia'
overlay= pygame.Overlay( pygame.PF_RGB16, SR)
while exit== 0 and x< 255:
  f= pygame.font.Font( 'data/arialn.ttf', 2+x )
  t= time.time()
  getOverlay( overlay, f, txt, 255- x )
  delta= time.time()- t
  if delta< 0.04:
    time.sleep( .04- delta )
  #ev= pygame.event.get()
  #for e in ev:
  
  e= pygame.event.wait()
  if e.type== pygame.KEYDOWN:
    if e.key== pygame.K_ESCAPE:
      exit= 1
      break
  
  x+= 2
  if exit== 1:
    break


pygame.event.wait()
pygame.quit()
